/*
Copyright (c) 2005-2008 TeamF1, Inc.
All rights reserved.
*/

/* add_vpn_policy.htm and edit_vpn_policy.htm */
function editVpnPolicyValidate ()
    {
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtVPName," +
                       "Please enter a name for the VPN policy";
    txtFieldIdArr[1] = "vpnPolicyRemoteEndpointFQDNTxt," + 
                       "Invalid FQDN. Please specify a Fully Qualified Domain Name for the remote endpoint";
    txtFieldIdArr[2] = "txtVPSPIIn," + 
                       "Please enter a valid incoming SPI for manual policy entry";
    txtFieldIdArr[3] = "manualPolicyKeyIn," + 
                       "Please enter the incoming encryption check key for manual policy entry";
    txtFieldIdArr[4] = "manualPolicyKeyOut," + 
                       "Please enter the outgoing encryption key for manual policy entry";
    txtFieldIdArr[5] = "txtVPSPIOut," + 
                       "Please enter a valid outgoing SPI for manual policy entry";
    txtFieldIdArr[6] = "txtVPIntKeyIn," + 
                       "Please enter the incoming integrity key for manual policy entry";
    txtFieldIdArr[7] = "txtVPIntKeyOut," + 
                       "Please enter the outgoing integrity check key for manual policy entry";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    var saLifeTimeSecObj = document.getElementById('txtVPSALifeTimeSec');
    if (saLifeTimeSecObj || !saLifeTimeSecObj.disabled)
    	{
    	var suffix = "seconds";
    	var type = comboSelectedValueGet ('selSaLifetimeType');
    	if (type != null)
    	    {
    	    switch (parseInt (type, 10))
    	    	{
    	    	case 1:
    	    		suffix = "kilo bytes";
    	    		break;
    	    	default:
    	    		break;
    	    	}
    	    }
	    if (numericValueRangeCheck (saLifeTimeSecObj, 1, 
	                            "Please enter a valid SA lifetime in " + suffix,
                                '', '', false, "", "") == false)
    	    return false;
        }
    /* validate all IP addresses: check for empty and invalid values */
    if (ipv4AddrOctetsValidate ('vpnPolicyRemoteendpointIPAddress', 'IP', false, true,
             "Invalid IP address for remote endpoint.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('localStartIP', 'IP', false, true,
             "Invalid  local starting IP address.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('localEndIP', 'IP', false, true,
             "Invalid  local ending IP address.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('localSubnet', 'SM', false, true,
             "Invalid local IP subnet mask..", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('remoteStartIP', 'IP', false, true,
             "Invalid  remote starting IP address.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('remoteEndIP', 'IP', false, true,
             "Invalid  remote ending IP address.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('remoteSubnet', 'SM', true, true,
             "Invalid remote IP subnet mask.", "for octet ", true) == false)
        return false;
        
	if (encrKeyLenValidate () == false)
		return false;
	if (intgAlgoKeyLenValidate () == false)
		return false;

    var selRemoteObj = document.getElementById ('selectRemoteIP');
    if (!selRemoteObj) return;  /* do not check for disable state */
    selRemoteObj.disabled = false;
    if( saValueRangeCheck () == false)
	return false;
    return true;
    }
    
function encrKeyLenValidate ()
	{
	var selEncrValue = comboSelectedValueGet ('selectManualPolicyEncAlg');
	if (selEncrValue == null)
         return true;
	var minKeyLen = 0;
	var errStr = "";
	switch (parseInt (selEncrValue, 10))
		{
		case 1:	/* DES */
			minKeyLen = 8;
			errStr = "for encryption algorithm: DES. Key must be 8 characters long.";
			break;
		case 2:	/* 3DES */
			minKeyLen = 24;
			errStr = "for encryption algorithm: 3DES. Key must be 24 characters long.";
			break;
		case 3:	/* AES-128 */
			minKeyLen = 16;
			errStr = "for encryption algorithm: AES-128. Key must be 16 characters long.";
			break;
		case 4:	/* AES-192 */
			minKeyLen = 24;
			errStr = "for encryption algorithm: AES-192. Key must be 24 characters long.";
			break;
		case 5:	/* AES-256 */
			minKeyLen = 32;
			errStr = "for encryption algorithm: AES-256. Key must be 32 characters long.";
			break;
		case 0:	/* NULL */
		default:
			minKeyLen = 0;
			errStr = "";
			break;
		}
    /* check for minimum length */
	if (fieldLengthCheck ('manualPolicyKeyIn', minKeyLen, minKeyLen,
				"Invalid Key-In length " + errStr) == false)
		return false;
	if (fieldLengthCheck ('manualPolicyKeyOut', minKeyLen, minKeyLen,
				"Invalid Key-Out length " + errStr) == false)
		return false;
    /* check for key validity */
    var keyInObj = document.getElementById ('manualPolicyKeyIn');
    if (keyInObj.disabled) return true;
    var keyOutObj = document.getElementById ('manualPolicyKeyOut');
    if (keyOutObj.disabled) return true;
	switch (parseInt (selEncrValue, 10))
		{
		case 2:	/* 3DES */
            splitPos = 8;
            errStr = "For 3DES, every 8 bytes in 24 byte key-in should be different";
            var keyInStr = keyInObj.value;
            if ((keyInStr.substring (0, splitPos) == 
                         keyInStr.substring (splitPos, splitPos + splitPos)) ||
                (keyInStr.substring (splitPos, splitPos + splitPos) == 
                         keyInStr.substring (splitPos  + splitPos)) ||
                (keyInStr.substring (0, splitPos) == 
                         keyInStr.substring (splitPos  + splitPos)))
                {
                alert (errStr);
                keyInObj.focus ();
                return false;
                }
            var keyOutStr = keyOutObj.value;
            errStr = "For 3DES, every 8 bytes in 24 byte key-out should be different";
            if ((keyOutStr.substring (0, splitPos) == 
                         keyOutStr.substring (splitPos, splitPos + splitPos)) || 
                (keyOutStr.substring (splitPos, splitPos + splitPos) == 
                         keyOutStr.substring (splitPos  + splitPos)) || 
                (keyOutStr.substring (0 , splitPos) == 
                         keyOutStr.substring (splitPos  + splitPos)))
                {
                alert (errStr);
                keyOutObj.focus ();
                return false;
                }
			break;
		case 1:	/* DES */
		case 3:	/* AES-128 */
		case 4:	/* AES-192 */
		case 5:	/* AES-256 */
		case 0:	/* NULL */
		default:
			minKeyLen = 0;
			errStr = "";
			break;
		}
    
	return true;
	}    
	
function intgAlgoKeyLenValidate ()
	{
	var selAlgoValue = comboSelectedValueGet ('selInetegrityAlgo');
	if (selAlgoValue == null) return true;
	var minKeyLen = 0;
	var errStr = "";
	switch (parseInt (selAlgoValue, 10))
		{
		case 1:	/* MD5 */
			minKeyLen = 16;
			errStr = "for integrity algorithm: MD5. Key must be 16 characters long.";
			break;
		case 2:	/* SHA1 */
			minKeyLen = 20;
			errStr = "for integrity algorithm: SHA1. Key must be 20 characters long.";
			break;
		default:
			minKeyLen = 0;
			errStr = "";
			break;
		}
	if (fieldLengthCheck ('txtVPIntKeyIn', minKeyLen, minKeyLen,
			"Invalid Key-In length " + errStr) == false)
		return false;
	if (fieldLengthCheck ('txtVPIntKeyOut', minKeyLen, minKeyLen,
			"Invalid Key-Out length length " + errStr) == false)
		return false;
	return true;
	}    	
